#!/bin/sh

# --------------------------------------------------
# Big Brother - Pager codes and system definitions
#
# NO CHANGES SHOULD BE NEEDED HERE
# --------------------------------------------------
#

BB="${BBHOME}/bin/bb"			# WHERE bb LIVES
BBHOSTS="${BBHOME}/etc/bb-hosts"        # BIG BROTHER HOSTS FILE
BBDFTAB="${BBHOME}/etc/bb-dftab"	# LEVELS BY DISK PARTITION
BBLOGS="${BBHOME}/www/logs"             # WHERE THE LOG FILES LIVE
BBNOTES="${BBHOME}/www/notes"           # WHERE THE SYSTEM NOTES LIVE
export BB BBHOSTS BBDFTAB BBLOGS BBNOTES

#
# IF NO PAGER NUMBER IS DEFINED, THEN DISABLE PAGING
#
if test "$PAGER" = ""
then
	DFPAGE=N			# PAGE ON DISK FULL (Y/N)
	CPUPAGE=N			# PAGE FOR CPU Y/N
	TELNETPAGE=N			# PAGE ON TELNET FAILURE?
	HTTPPAGE=N			# PAGE ON HTTP FAILURE?
fi

#
# PAGER ERROR CODES (THESE SHOULDN'T BE ADJUSTED)
#
DISKERR="100"				# DISK ERROR CODES FOR PAGER
CPUERR="200"				# CPU LOAD ERROR CODES
PROCERR="300"				# PROCESSES ERROR CODES
MSGERR="400"				# MESSAGES ERROR CODE
TELNETERR="500"				# TELNET ERROR CODE
HTTPERR="600"				# HTTP ERROR CODE
NETERR="7"				# NETWORK ERROR 7 + PORT NUMBER
DNSERR="800"				# DNS ERROR
export DISKERR CPUERR PROCERR MSGERR TELNETERR HTTPERR NETERR DNSERR


#
# FIGURE OUT THE LOCAL MACHINE NAME
# USE FULLY QUALIFIED MACHINE NAMES?
# DOT -> COMMA -> DOT FOR WEB DISPLAY
#
MACHINE=`uname -n`			# WHO ARE WE?  MAY NOT BE FQDN!
set `$GREP $MACHINE $BBHOSTS`
MACHINE=$2				# GET FQDN NAME FROM etc/bb-hosts
MACHIP=`echo $1 | $SED "s/\.//g"`	# IP ADDRESS FOR PAGER DISPLAY

if test "$FQDN" = "TRUE"
then
	MACHINE=`echo $MACHINE | $SED "s/\./,/g"`
else
	set `echo $MACHINE | $SED "s/\./ /"`
	MACHINE=$1
fi

export MACHINE MACHIP

#
# WHERE THE BIG BROTHER SERVERS LIVE
# LOOK IN bb-hosts FOR DISPLAY AND PAGER
#
BBDISP=`$GREP BBDISPLAY $BBHOSTS`
if test "$BBDISP" = ""
then
	echo "BBDISPLAY NOT SET IN $BBHOSTS - Big Brother won't work!" 
	exit 1
else
	set $BBDISP
	BBDISP=$1			# IP ADDRESS OF THE BB DISPLAY
fi

BBPAGE=`$GREP BBPAGER $BBHOSTS`
if test "$BBPAGE" = ""
then
	BBPAGE=$BBDISP			# SENSIBLE DEFAULT
else
	set $BBPAGE
	BBPAGE=$1			# GET THE IP ADDR OF THE PAGER
fi

export BBDISP BBPAGE

#echo "=====> $MACHINE $MACHIP $BBDISP $BBPAGE"
