#!/bin/sh

# runbb.sh
# BIG BROTHER MAIN SCRIPT
# Sean MacGuire - The MacLawran Group Inc.
# Version 1.06
# Dec 30, 1997
#
# This program is Copyright (c) 1997 
# The MacLawran Group Inc.
# All Rights Reserved
#
# THE MOTHER OF ALL SHELL SCRIPTS...
#

#
# BBHOME IS THE ROOT DIRECTORY OF BIG BROTHER!!!
# YOU MUST SET THE NEXT LINE TO WHERE BB LIVES
BBHOME="/usr/local/bb" 

export BBHOME

if test "$BBHOME" = ""
then
	echo "BBHOME IS NOT SET IN runbb.sh"
	echo "Please edit runbb.sh and correct this problem!"
	exit 1
fi

. $BBHOME/etc/bbdef.sh		# GET STANDARD INCLUDES

BBSLEEP=300			# HOW OFTEN TO UPDATE (IN SECONDS)

#
# FIRST, SEE IF THIS MACHINE IS EITHER THE DISPLAY SERVER
# THE PAGER SERVER, OR BOTH...
#
grep `uname -n` $BBHOME/etc/bb-hosts > ${BBTMP}/BB.$$

grep BBDISPLAY ${BBTMP}/BB.$$ > /dev/null 2>&1
if test "$?" = "0"		# WE'RE A DISPLAY SERVER
then
	BBDISPLAY="TRUE"
	BBSERVER="TRUE"
fi

grep BBPAGER ${BBTMP}/BB.$$ > /dev/null 2>&1
if test "$?" = "0"
then
	BBPAGER="TRUE"		# WE'RE A PAGER SERVER
	BBSERVER="TRUE"
fi

grep BBNET ${BBTMP}/BB.$$ > /dev/null 2>&1
if test "$?" = "0"
then
	BBNET="TRUE"		# WE'RE A NETWORK MONITOR
fi

#
# IF WE NEED THE BIG BROTHER DAEMON ON THIS MACHINE THEN START IT
#
if test "$BBSERVER" = "TRUE"
then
	echo "Starting Big Brother Daemon (bbd)..."
	$BBHOME/bin/bbd
	sleep 3			# PAUSE...
fi

echo "Starting Big Brother Collectors..."

$RM -f ${BBTMP}/BB.$$
$RM -f ${PAGINGLOCK}		# Spotted by Martin Richard

#
# NOW RUN THE CLIENT LOOP...
#
while true
do
	# echo "*** CALLING BB-LOCAL ***"
	$BBHOME/bin/bb-local.sh			# COLLECT LOCAL INFO

	if test "$BBNET" = "TRUE"
	then
		# echo "*** CALLING BB-NETWORK ***"
		$BBHOME/bin/bb-network.sh	# COLLECT NET INFO
	fi

	if test "$BBDISPLAY" = "TRUE"
	then
		# echo "*** MAKING WEB PAGES  ***"
		$BBHOME/web/mkbb.sh > ${BBTMP}/BB.$$        # MAKE BB PAGE
		mv ${BBTMP}/BB.$$ $BBHOME/www/bb.html       # MOVE IT IN
		$BBHOME/web/mkbb2.sh > ${BBTMP}/BB.$$       # MAKE QUICK VIEW
		mv ${BBTMP}/BB.$$ $BBHOME/www/bb2.html      # MOVE IT IN
	fi

	sleep $BBSLEEP				# PAUSE
done
