#!/bin/sh

# mkbb.sh
# SHELL SCRIPT TO MAKE THE BIG BROTHER WEB DISPLAY
# Sean MacGuire - The MacLawran Group Inc.
# Version 1.08a - 8 aug 1998
#
# This program is Copyright (c) 1997, 1998
# The MacLawran Group Inc.
# All Rights Reserved

if test ! "$BBTMP"                      # GET DEFINITIONS IF NEEDED
then
        . $BBHOME/etc/bbdef.sh          # INCLUDE STANDARD DEFINITIONS
fi

#
# FIND OUT IF WE HAVE ANY OLD DATA FILES LYING AROUND...
# touchtime is a C program that creates a file 30 minutes old
#
$BBHOME/bin/touchtime ${BBLOGS}/later	# MAKE THE TOUCH FILE
$FIND $BBLOGS -type f ! -newer ${BBLOGS}/later -print | $GREP -v later | $GREP -v backup > $BBTMP/OLD.$$

for file in `${CAT} $BBTMP/OLD.$$`
do
	set `${CAT} $file`
	COLOR=$1
	${CAT} $file | $SED "s/${COLOR}/purple/g" > $BBTMP/NEW.$$
	mv $BBTMP/NEW.$$ $file
done
$RM $BBTMP/OLD.$$

BBBKG=`${BBHOME}/web/mkbb.bkg`		# GET THE BACKGROUND COLOR
BBDATE=`${DATE}`			# SET THE DATE
BBTIME=`${DATE} +%H:%M`		# SET THE TIME

#
# SMM: NEW IN 1.05 - SUPPORT FOR SENDING SUMMARY INFORMATION UPSTREAM
# bb-hosts LINES OF THE FORMAT:
#
#	summary row.column	IP-ADDRESS-OF-PARENT	http://address.here.com/
#	summary quebec.montreal	123.123.123.123 http://MacLawran.ca/bb/
#
$CAT $BBHOSTS | $GREP "^summary" |
while read line
do
	set $line
	BBNAME=$2
	BBSUMMARY=$3
	BBHTTP=$4
	$BB $BBSUMMARY "status summary.${BBNAME} $BBBKG $BBHTTP $BBDATE"
done


ALLCOLS=`${BBHOME}/web/mkbb.cols`	# GET OUR COLUMN HEADINGS
COLUMNS="$ALLCOLS"			# THANKS Rob!

#
# Thanks to "Alistair K. Birch" <birch@birch.de>
# who reminded me that Explorer needs Height and Width tags!
#


echo "
<HTML>
<HEAD>

<!-- 
	The Big Brother System and Network Monitor - v.1.08a - 05 Sep 1998
	Copyright 1997, 1998 The MacLawran Group Inc. - All Rights Reserved 
	Non-commercial use only
	From: http://MacLawran.ca/bb-dnld/
	Contact: sean@MacLawran.CA
-->

<TITLE>Big Brother - Network status @ $BBDATE</TITLE>
<META NAME=\"KEYWORDS\" CONTENT=\"big brother,MacLawran,monitoring\">
<META NAME=\"DESCRIPTION\" CONTENT=\"Big Brother System & Network Monitor\">
<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"60\">
<META HTTP-EQUIV=\"EXPIRES\" CONTENT=\"$BBDATE\"> 
<META HTTP-EQUIV=\"PRAGMA\" CONTENT=\"NO-CACHE\"> 
</HEAD>

<BODY BACKGROUND=\"gifs/bkg-${BBBKG}.gif\" 
	TEXT=#FFFFFF LINK=\"#00FFAA\" VLINK=\"#FFFF44\">
<CENTER>

<TABLE CELLPADDING=5><TR>
<TD VALIGN=TOP>
<H3>Legend</H3>
<B><I>
<IMG SRC=\"gifs/green.gif\" ALT=\"green\" HEIGHT=12 WIDTH=12 > System OK<BR>
<IMG SRC=\"gifs/yellow.gif\" ALT=\"yellow\" HEIGHT=12 WIDTH=12 > Attention<BR>
<IMG SRC=\"gifs/red.gif\" ALT=\"red\" HEIGHT=12 WIDTH=12 > Trouble<BR>
<IMG SRC=\"gifs/purple.gif\" ALT=\"blue\" HEIGHT=12 WIDTH=12 > No report<BR><BR>
</I></B>
<H3>Updated<BR><I>@ $BBTIME </I></H3>
</TD><TD>
<A HREF=\"http://MacLawran.ca/bb-dnld/\">
<IMG SRC=\"gifs/bb.gif\" ALT=\"BIG BROTHER\" WIDTH=176 HEIGHT=166 BORDER=0></A><BR><BR></TD>
<TD ALIGN=RIGHT VALIGN=ABSMIDDLE>
<A HREF=\"bb-help.html\"><IMG SRC=\"gifs/buthelp.gif\" HEIGHT=29 WIDTH=74 BORDER=0 VSPACE=7 ALT=\"help\"></A><BR>
<A HREF=\"bb-info.html\"><IMG SRC=\"gifs/butinfo.gif\" HEIGHT=29 WIDTH=74 BORDER=0 VSPACE=7 ALT=\"info\"></A><BR>
<A HREF=\"bb-page.html\"><IMG SRC=\"gifs/butpage.gif\" HEIGHT=29 WIDTH=74 BORDER=0 VSPACE=7 ALT=\"page\"></A><BR>
<A HREF=\"bb2.html\"><IMG SRC=\"gifs/butview.gif\" HEIGHT=29 WIDTH=74 BORDER=0 VSPACE=7 ALT=\"view\"></A>
</TD>
</TR></TABLE>
"

#
# SMM 1.08
# GET TOTAL NUMBER OF COLUMNS
# DO THIS ONCE.
#
TOTCOL="1"
for column in $ALLCOLS
do
	TOTCOL=`expr $TOTCOL + 1`
done

BBHOSTLINE=0					# WHAT LINE OF bb-hosts ARE WE ON?

#
# FOR EACH HOST WE CARE ABOUT...
#
$CAT $BBHOSTS | 
while read line
do
	BBHOSTLINE=`expr $BBHOSTLINE + 1`

	#
	# FIX THIS LINE SOONER OR LATER - THE > /dev/null BREAKS ON
	# DEC ULTRIX.  GREAT EH?
	#
	set $line > /dev/null			# SMM 1.06a ENV DISPLAY BUG!

	#
	# SMM 1.06a SUPPORT FOR GROUPING THINGS TOGETHER
	# IF THE LINE STARTS WITH THE WORD group THEN
	# A NEW TABLE IS CREATED WITH THE REST OF THE LINE
	# AS THE CENTERED LABEL, i.e.
	# group Web and Mail Servers
	#
	# SMM 1.08 SUPPORT FOR COMPRESSED GROUPINGS
	# IF THERE IS ONLY ONE COLUMN IN THE GROUP, DISPLAY THEM
	# ACROSS THE SCREEN, OTHERWISE JUST ELIMINATE UNNEEDED COLUMNS
	#
	echo $1 | $GREP "^group" > /dev/null	# IT'S A GROUP LINE
	if test "$?" = "0"
	then
		echo $1 | $GREP "^group-compress" > /dev/null
		if test "$?" = "0" 
		then				# COMPRESS COLUMNS
			COLUMNS=`${BBHOME}/web/mkbb.cols $BBHOSTLINE`
			TOTCOLS="1"
			for column in $COLUMNS
			do
				TOTCOLS=`expr $TOTCOLS + 1`
			done
		else				# ALL COLUMNS
			COLUMNS="$ALLCOLS"
			TOTCOLS="$TOTCOL"
		fi

		if test "$NAME" != ""		# CLOSE OFF TABLE
		then
			echo "</TABLE><P>"
		fi
		echo "<TABLE BORDER=3><TR><TD COLSPAN=$TOTCOLS>"
		shift;				# GET RID OF group
		echo "<CENTER>$*</CENTER></TD></TR><TR><TD></TD>"

		for column in $COLUMNS		# REDISPLAY HEADERS
		do
			echo "<TD ALIGN=CENTER WIDTH=45><H4>
			<A HREF=\"bb-help.html#${column}\">
			<I>$column</I></A></H4></TD>"
		done
		TOP="DONE"			# SMM FOR TOP LINE DISP
		echo "</TR>"
		continue;
	else					# BETTER BE AN IP ADDR
		echo $1 | $GREP "^[0-9]" > /dev/null
		if test "$?" = "1"		# NOT VALID
		then
			continue;		# SKIP TO NEXT ONE
		fi

		#
		# SMM 1.06a
		# WE MAY NOT HAVE A group DIRECTIVE THAT CREATED
		# THE TABLE.  HANDLE IT HERE.
		#
		if test "$TOP" = ""		# TOP LINE NOT DONE
		then
			echo "<TABLE BORDER=3><TR><TD></TD>"
			for column in $COLUMNS
			do
				echo "<TD ALIGN=CENTER WIDTH=45><H4>
				<A HREF=\"bb-help.html#${column}\">
				<I>$column</I></A></H4></TD>"
			done
			TOP="DONE"
			echo "</TR>"
		fi
	fi

	#
	# NEW FOR 1.04 - SUPPORT FOR FQDN's
	# NOT CENTERED...
	#
	if test "$FQDN" != ""
	then
		FNAME="$2"
		echo "<TR><TD>"
		NAME=`echo $2 | $SED "s/\./,/g"`
	else
		set `echo $2 | $SED "s/\./ /"`
		NAME=$1
		FNAME="$NAME"
		echo "<TR><TD ALIGN=CENTER>"
	fi

	#
	# PUT A LINK IN FOR SYSTEM NOTES IF WE HAVE ANY
	# THIS IS A GOOD PLACE TO PUT INVENTORY INFO
	# SMM NEW IN 1.05: SUPPORT FOR .html and .htm EXTENSIONS
	# DON'T ASK FOR UPPERCASE EXTENSIONS.  EVER.
	#
	if test -f "${BBNOTES}/${FNAME}.html"
	then
		echo "<A HREF=notes/${FNAME}.html> <B>$FNAME</B></A></TD>"
	elif test -f "${BBNOTES}/${FNAME}.htm"
	then
		echo "<A HREF=notes/${FNAME}.htm> <B>$FNAME</B></A></TD>"
	elif test -f "${BBNOTES}/${FNAME}"
        then
		echo "<A HREF=notes/$FNAME> <B>$FNAME</B></A></TD>"
	else
		echo "<B>$FNAME</B></TD>"
	fi

	#
	# FOR EACH OF THE THINGS WE MONITOR...
	#
	for column in $COLUMNS
	do
		if test -f "$BBLOGS/${NAME}.${column}"
		then
			set `${CAT} ${BBLOGS}/${NAME}.${column}`
			echo "<TD ALIGN=CENTER><A HREF=\"logs/$NAME.$column\">
				<IMG SRC=\"gifs/$1.gif\" ALT=\"$1\" HEIGHT=12 WIDTH=12 BORDER=0></A></TD>"
			
		else
		echo "<TD ALIGN=CENTER>-</TD>"
		fi
	done
	echo "</TR>"
done
echo "</TABLE>"				# END OF TABLE

#
# SMM NEW IN 1.05 - SUPPORT FOR DISPLAY OF SUMMARY INFORMATION
#
echo "<BR><TABLE BORDER=3>"
$LS ${BBLOGS}/summary* 2> /dev/null| $SORT |
while read line
do
	set `echo $line | $SED "s/\./ /g"`
	ROW=$2
	COL=$3

	#
	# HANDLE THE ROW DISPLAY 
	#
	if test "$ROW" != "$LASTROW"		# WE HAVE A NEW ROW...
	then
		if test "$LASTROW" != ""
		then
			echo "</TR>"
		fi

		#
		# SMM: NEW IN 1.06a
		# SUPPORT FOR NOTES IN THE SUMMARY LINES
		# VIA: David Fordyce <fordyce@ite1.dseg.ti.com>
		#
		echo "<TR><TD><B>"

		if test -f "${BBNOTES}/${ROW}.html"
		then
			echo "<A HREF=notes/${ROW}.html>$ROW</B></A></TD>"
		elif test -f "${BBNOTES}/${ROW}.htm"
		then
			echo "<A HREF=notes/${ROW}.htm>$ROW</B></A></TD>"
		elif test -f "${BBNOTES}/${ROW}"
        	then
			echo "<A HREF=notes/$ROW>$ROW</B></A></TD>"
		else
			echo "$ROW</B></TD>"
		fi

		LASTROW="$ROW"
	fi
	#
	# HANDLE THE COLUMN DISPLAY
	#
	echo "<TD WIDTH=45 ALIGN=CENTER>$COL<BR>"	# COLUMN TITLE
	set `$CAT ${BBLOGS}/summary.${ROW}.${COL}`
	echo "<A HREF=$2><IMG SRC=\"gifs/$1.gif\" ALT=\"green\" HEIGHT=12 WIDTH=12 BORDER=0></A></TD>"
done
echo "</TABLE>"


echo "<P><TABLE BORDER=3>"
#
# SMM NEW IN 1.05 - SUPPORT FOR MONITORING MODEM BANKS
#
$CAT $BBHOSTS | $GREP "^dialup" |
while read line
do
	set $line

	FNAME=$2

	#
	# PUT IN A LINK...
	#
	echo "<TR><TD>"				# MAKE A NEW ROW...
	if test -f "${BBNOTES}/${FNAME}.html"
	then
		echo "<A HREF=notes/${FNAME}.html> <B>$FNAME</B></A></TD>"
	elif test -f "${BBNOTES}/${FNAME}.htm"
	then
		echo "<A HREF=notes/${FNAME}.htm> <B>$FNAME</B></A></TD>"
	else
		echo "<B>$FNAME</B></TD>"
	fi

	if test -f "$BBLOGS/dialup.${FNAME}"
	then
		set `$CAT $BBLOGS/dialup.${FNAME}`
		while test "$1" != "DATA"
		do
			shift;
		done
		shift;		# GO PAST THE DATA LINE
		#
		# NOW MAKE NICE PICTURES
		#
		while test "$1"
		do
			echo "<TD ALIGN=CENTER><A HREF=\"logs/dialup.${FNAME}\">"
			echo "<IMG SRC=\"gifs/$1.gif\" ALT=$1 HEIGHT=12 WIDTH=12 BORDER=0></A>"
			echo "</TD>"
			shift;
		done
		echo "</TR>"
	fi
done
echo "</TABLE>"

#
# SMM NEW IN 1.04 - STANDARD FOOTER
#
if test -f "${BBNOTES}/footer"
then
	echo "<P>"
	cat ${BBNOTES}/footer
fi
echo "</CENTER></BODY></HTML>"		# END OF HTML DOCUMENT
